diff --git a/build.sh b/build.sh
index f73b3ed..f4d4582 100755
--- a/build.sh
+++ b/build.sh
@@ -87,7 +87,7 @@ elif [ "$CLEAN_SLATE" ]; then
fi
## Run Docker
-docker run --rm -it \
+docker run --rm -it --network host \
--user "$(id -u):$(id -g)" \
-v "$PWD/$MODEL/build:$DOCKER_COREBOOT_DIR" \
-v "$PWD/$MODEL:$DOCKER_SCRIPT_DIR" \
diff --git a/x230t/.gitignore b/x230t/.gitignore
new file mode 100644
index 0000000..aa38397
--- /dev/null
+++ b/x230t/.gitignore
@@ -0,0 +1,4 @@
+/output
+x230_coreboot_seabios_*rom*
+x230t_coreboot_seabios_*rom*
+/build
diff --git a/x230t/LICENSE b/x230t/LICENSE
new file mode 100644
index 0000000..94a9ed0
--- /dev/null
+++ b/x230t/LICENSE
@@ -0,0 +1,674 @@
+ GNU GENERAL PUBLIC LICENSE
+ Version 3, 29 June 2007
+
+ Copyright (C) 2007 Free Software Foundation, Inc.
+ Everyone is permitted to copy and distribute verbatim copies
+ of this license document, but changing it is not allowed.
+
+ Preamble
+
+ The GNU General Public License is a free, copyleft license for
+software and other kinds of works.
+
+ The licenses for most software and other practical works are designed
+to take away your freedom to share and change the works. By contrast,
+the GNU General Public License is intended to guarantee your freedom to
+share and change all versions of a program--to make sure it remains free
+software for all its users. We, the Free Software Foundation, use the
+GNU General Public License for most of our software; it applies also to
+any other work released this way by its authors. You can apply it to
+your programs, too.
+
+ When we speak of free software, we are referring to freedom, not
+price. Our General Public Licenses are designed to make sure that you
+have the freedom to distribute copies of free software (and charge for
+them if you wish), that you receive source code or can get it if you
+want it, that you can change the software or use pieces of it in new
+free programs, and that you know you can do these things.
+
+ To protect your rights, we need to prevent others from denying you
+these rights or asking you to surrender the rights. Therefore, you have
+certain responsibilities if you distribute copies of the software, or if
+you modify it: responsibilities to respect the freedom of others.
+
+ For example, if you distribute copies of such a program, whether
+gratis or for a fee, you must pass on to the recipients the same
+freedoms that you received. You must make sure that they, too, receive
+or can get the source code. And you must show them these terms so they
+know their rights.
+
+ Developers that use the GNU GPL protect your rights with two steps:
+(1) assert copyright on the software, and (2) offer you this License
+giving you legal permission to copy, distribute and/or modify it.
+
+ For the developers' and authors' protection, the GPL clearly explains
+that there is no warranty for this free software. For both users' and
+authors' sake, the GPL requires that modified versions be marked as
+changed, so that their problems will not be attributed erroneously to
+authors of previous versions.
+
+ Some devices are designed to deny users access to install or run
+modified versions of the software inside them, although the manufacturer
+can do so. This is fundamentally incompatible with the aim of
+protecting users' freedom to change the software. The systematic
+pattern of such abuse occurs in the area of products for individuals to
+use, which is precisely where it is most unacceptable. Therefore, we
+have designed this version of the GPL to prohibit the practice for those
+products. If such problems arise substantially in other domains, we
+stand ready to extend this provision to those domains in future versions
+of the GPL, as needed to protect the freedom of users.
+
+ Finally, every program is threatened constantly by software patents.
+States should not allow patents to restrict development and use of
+software on general-purpose computers, but in those that do, we wish to
+avoid the special danger that patents applied to a free program could
+make it effectively proprietary. To prevent this, the GPL assures that
+patents cannot be used to render the program non-free.
+
+ The precise terms and conditions for copying, distribution and
+modification follow.
+
+ TERMS AND CONDITIONS
+
+ 0. Definitions.
+
+ "This License" refers to version 3 of the GNU General Public License.
+
+ "Copyright" also means copyright-like laws that apply to other kinds of
+works, such as semiconductor masks.
+
+ "The Program" refers to any copyrightable work licensed under this
+License. Each licensee is addressed as "you". "Licensees" and
+"recipients" may be individuals or organizations.
+
+ To "modify" a work means to copy from or adapt all or part of the work
+in a fashion requiring copyright permission, other than the making of an
+exact copy. The resulting work is called a "modified version" of the
+earlier work or a work "based on" the earlier work.
+
+ A "covered work" means either the unmodified Program or a work based
+on the Program.
+
+ To "propagate" a work means to do anything with it that, without
+permission, would make you directly or secondarily liable for
+infringement under applicable copyright law, except executing it on a
+computer or modifying a private copy. Propagation includes copying,
+distribution (with or without modification), making available to the
+public, and in some countries other activities as well.
+
+ To "convey" a work means any kind of propagation that enables other
+parties to make or receive copies. Mere interaction with a user through
+a computer network, with no transfer of a copy, is not conveying.
+
+ An interactive user interface displays "Appropriate Legal Notices"
+to the extent that it includes a convenient and prominently visible
+feature that (1) displays an appropriate copyright notice, and (2)
+tells the user that there is no warranty for the work (except to the
+extent that warranties are provided), that licensees may convey the
+work under this License, and how to view a copy of this License. If
+the interface presents a list of user commands or options, such as a
+menu, a prominent item in the list meets this criterion.
+
+ 1. Source Code.
+
+ The "source code" for a work means the preferred form of the work
+for making modifications to it. "Object code" means any non-source
+form of a work.
+
+ A "Standard Interface" means an interface that either is an official
+standard defined by a recognized standards body, or, in the case of
+interfaces specified for a particular programming language, one that
+is widely used among developers working in that language.
+
+ The "System Libraries" of an executable work include anything, other
+than the work as a whole, that (a) is included in the normal form of
+packaging a Major Component, but which is not part of that Major
+Component, and (b) serves only to enable use of the work with that
+Major Component, or to implement a Standard Interface for which an
+implementation is available to the public in source code form. A
+"Major Component", in this context, means a major essential component
+(kernel, window system, and so on) of the specific operating system
+(if any) on which the executable work runs, or a compiler used to
+produce the work, or an object code interpreter used to run it.
+
+ The "Corresponding Source" for a work in object code form means all
+the source code needed to generate, install, and (for an executable
+work) run the object code and to modify the work, including scripts to
+control those activities. However, it does not include the work's
+System Libraries, or general-purpose tools or generally available free
+programs which are used unmodified in performing those activities but
+which are not part of the work. For example, Corresponding Source
+includes interface definition files associated with source files for
+the work, and the source code for shared libraries and dynamically
+linked subprograms that the work is specifically designed to require,
+such as by intimate data communication or control flow between those
+subprograms and other parts of the work.
+
+ The Corresponding Source need not include anything that users
+can regenerate automatically from other parts of the Corresponding
+Source.
+
+ The Corresponding Source for a work in source code form is that
+same work.
+
+ 2. Basic Permissions.
+
+ All rights granted under this License are granted for the term of
+copyright on the Program, and are irrevocable provided the stated
+conditions are met. This License explicitly affirms your unlimited
+permission to run the unmodified Program. The output from running a
+covered work is covered by this License only if the output, given its
+content, constitutes a covered work. This License acknowledges your
+rights of fair use or other equivalent, as provided by copyright law.
+
+ You may make, run and propagate covered works that you do not
+convey, without conditions so long as your license otherwise remains
+in force. You may convey covered works to others for the sole purpose
+of having them make modifications exclusively for you, or provide you
+with facilities for running those works, provided that you comply with
+the terms of this License in conveying all material for which you do
+not control copyright. Those thus making or running the covered works
+for you must do so exclusively on your behalf, under your direction
+and control, on terms that prohibit them from making any copies of
+your copyrighted material outside their relationship with you.
+
+ Conveying under any other circumstances is permitted solely under
+the conditions stated below. Sublicensing is not allowed; section 10
+makes it unnecessary.
+
+ 3. Protecting Users' Legal Rights From Anti-Circumvention Law.
+
+ No covered work shall be deemed part of an effective technological
+measure under any applicable law fulfilling obligations under article
+11 of the WIPO copyright treaty adopted on 20 December 1996, or
+similar laws prohibiting or restricting circumvention of such
+measures.
+
+ When you convey a covered work, you waive any legal power to forbid
+circumvention of technological measures to the extent such circumvention
+is effected by exercising rights under this License with respect to
+the covered work, and you disclaim any intention to limit operation or
+modification of the work as a means of enforcing, against the work's
+users, your or third parties' legal rights to forbid circumvention of
+technological measures.
+
+ 4. Conveying Verbatim Copies.
+
+ You may convey verbatim copies of the Program's source code as you
+receive it, in any medium, provided that you conspicuously and
+appropriately publish on each copy an appropriate copyright notice;
+keep intact all notices stating that this License and any
+non-permissive terms added in accord with section 7 apply to the code;
+keep intact all notices of the absence of any warranty; and give all
+recipients a copy of this License along with the Program.
+
+ You may charge any price or no price for each copy that you convey,
+and you may offer support or warranty protection for a fee.
+
+ 5. Conveying Modified Source Versions.
+
+ You may convey a work based on the Program, or the modifications to
+produce it from the Program, in the form of source code under the
+terms of section 4, provided that you also meet all of these conditions:
+
+ a) The work must carry prominent notices stating that you modified
+ it, and giving a relevant date.
+
+ b) The work must carry prominent notices stating that it is
+ released under this License and any conditions added under section
+ 7. This requirement modifies the requirement in section 4 to
+ "keep intact all notices".
+
+ c) You must license the entire work, as a whole, under this
+ License to anyone who comes into possession of a copy. This
+ License will therefore apply, along with any applicable section 7
+ additional terms, to the whole of the work, and all its parts,
+ regardless of how they are packaged. This License gives no
+ permission to license the work in any other way, but it does not
+ invalidate such permission if you have separately received it.
+
+ d) If the work has interactive user interfaces, each must display
+ Appropriate Legal Notices; however, if the Program has interactive
+ interfaces that do not display Appropriate Legal Notices, your
+ work need not make them do so.
+
+ A compilation of a covered work with other separate and independent
+works, which are not by their nature extensions of the covered work,
+and which are not combined with it such as to form a larger program,
+in or on a volume of a storage or distribution medium, is called an
+"aggregate" if the compilation and its resulting copyright are not
+used to limit the access or legal rights of the compilation's users
+beyond what the individual works permit. Inclusion of a covered work
+in an aggregate does not cause this License to apply to the other
+parts of the aggregate.
+
+ 6. Conveying Non-Source Forms.
+
+ You may convey a covered work in object code form under the terms
+of sections 4 and 5, provided that you also convey the
+machine-readable Corresponding Source under the terms of this License,
+in one of these ways:
+
+ a) Convey the object code in, or embodied in, a physical product
+ (including a physical distribution medium), accompanied by the
+ Corresponding Source fixed on a durable physical medium
+ customarily used for software interchange.
+
+ b) Convey the object code in, or embodied in, a physical product
+ (including a physical distribution medium), accompanied by a
+ written offer, valid for at least three years and valid for as
+ long as you offer spare parts or customer support for that product
+ model, to give anyone who possesses the object code either (1) a
+ copy of the Corresponding Source for all the software in the
+ product that is covered by this License, on a durable physical
+ medium customarily used for software interchange, for a price no
+ more than your reasonable cost of physically performing this
+ conveying of source, or (2) access to copy the
+ Corresponding Source from a network server at no charge.
+
+ c) Convey individual copies of the object code with a copy of the
+ written offer to provide the Corresponding Source. This
+ alternative is allowed only occasionally and noncommercially, and
+ only if you received the object code with such an offer, in accord
+ with subsection 6b.
+
+ d) Convey the object code by offering access from a designated
+ place (gratis or for a charge), and offer equivalent access to the
+ Corresponding Source in the same way through the same place at no
+ further charge. You need not require recipients to copy the
+ Corresponding Source along with the object code. If the place to
+ copy the object code is a network server, the Corresponding Source
+ may be on a different server (operated by you or a third party)
+ that supports equivalent copying facilities, provided you maintain
+ clear directions next to the object code saying where to find the
+ Corresponding Source. Regardless of what server hosts the
+ Corresponding Source, you remain obligated to ensure that it is
+ available for as long as needed to satisfy these requirements.
+
+ e) Convey the object code using peer-to-peer transmission, provided
+ you inform other peers where the object code and Corresponding
+ Source of the work are being offered to the general public at no
+ charge under subsection 6d.
+
+ A separable portion of the object code, whose source code is excluded
+from the Corresponding Source as a System Library, need not be
+included in conveying the object code work.
+
+ A "User Product" is either (1) a "consumer product", which means any
+tangible personal property which is normally used for personal, family,
+or household purposes, or (2) anything designed or sold for incorporation
+into a dwelling. In determining whether a product is a consumer product,
+doubtful cases shall be resolved in favor of coverage. For a particular
+product received by a particular user, "normally used" refers to a
+typical or common use of that class of product, regardless of the status
+of the particular user or of the way in which the particular user
+actually uses, or expects or is expected to use, the product. A product
+is a consumer product regardless of whether the product has substantial
+commercial, industrial or non-consumer uses, unless such uses represent
+the only significant mode of use of the product.
+
+ "Installation Information" for a User Product means any methods,
+procedures, authorization keys, or other information required to install
+and execute modified versions of a covered work in that User Product from
+a modified version of its Corresponding Source. The information must
+suffice to ensure that the continued functioning of the modified object
+code is in no case prevented or interfered with solely because
+modification has been made.
+
+ If you convey an object code work under this section in, or with, or
+specifically for use in, a User Product, and the conveying occurs as
+part of a transaction in which the right of possession and use of the
+User Product is transferred to the recipient in perpetuity or for a
+fixed term (regardless of how the transaction is characterized), the
+Corresponding Source conveyed under this section must be accompanied
+by the Installation Information. But this requirement does not apply
+if neither you nor any third party retains the ability to install
+modified object code on the User Product (for example, the work has
+been installed in ROM).
+
+ The requirement to provide Installation Information does not include a
+requirement to continue to provide support service, warranty, or updates
+for a work that has been modified or installed by the recipient, or for
+the User Product in which it has been modified or installed. Access to a
+network may be denied when the modification itself materially and
+adversely affects the operation of the network or violates the rules and
+protocols for communication across the network.
+
+ Corresponding Source conveyed, and Installation Information provided,
+in accord with this section must be in a format that is publicly
+documented (and with an implementation available to the public in
+source code form), and must require no special password or key for
+unpacking, reading or copying.
+
+ 7. Additional Terms.
+
+ "Additional permissions" are terms that supplement the terms of this
+License by making exceptions from one or more of its conditions.
+Additional permissions that are applicable to the entire Program shall
+be treated as though they were included in this License, to the extent
+that they are valid under applicable law. If additional permissions
+apply only to part of the Program, that part may be used separately
+under those permissions, but the entire Program remains governed by
+this License without regard to the additional permissions.
+
+ When you convey a copy of a covered work, you may at your option
+remove any additional permissions from that copy, or from any part of
+it. (Additional permissions may be written to require their own
+removal in certain cases when you modify the work.) You may place
+additional permissions on material, added by you to a covered work,
+for which you have or can give appropriate copyright permission.
+
+ Notwithstanding any other provision of this License, for material you
+add to a covered work, you may (if authorized by the copyright holders of
+that material) supplement the terms of this License with terms:
+
+ a) Disclaiming warranty or limiting liability differently from the
+ terms of sections 15 and 16 of this License; or
+
+ b) Requiring preservation of specified reasonable legal notices or
+ author attributions in that material or in the Appropriate Legal
+ Notices displayed by works containing it; or
+
+ c) Prohibiting misrepresentation of the origin of that material, or
+ requiring that modified versions of such material be marked in
+ reasonable ways as different from the original version; or
+
+ d) Limiting the use for publicity purposes of names of licensors or
+ authors of the material; or
+
+ e) Declining to grant rights under trademark law for use of some
+ trade names, trademarks, or service marks; or
+
+ f) Requiring indemnification of licensors and authors of that
+ material by anyone who conveys the material (or modified versions of
+ it) with contractual assumptions of liability to the recipient, for
+ any liability that these contractual assumptions directly impose on
+ those licensors and authors.
+
+ All other non-permissive additional terms are considered "further
+restrictions" within the meaning of section 10. If the Program as you
+received it, or any part of it, contains a notice stating that it is
+governed by this License along with a term that is a further
+restriction, you may remove that term. If a license document contains
+a further restriction but permits relicensing or conveying under this
+License, you may add to a covered work material governed by the terms
+of that license document, provided that the further restriction does
+not survive such relicensing or conveying.
+
+ If you add terms to a covered work in accord with this section, you
+must place, in the relevant source files, a statement of the
+additional terms that apply to those files, or a notice indicating
+where to find the applicable terms.
+
+ Additional terms, permissive or non-permissive, may be stated in the
+form of a separately written license, or stated as exceptions;
+the above requirements apply either way.
+
+ 8. Termination.
+
+ You may not propagate or modify a covered work except as expressly
+provided under this License. Any attempt otherwise to propagate or
+modify it is void, and will automatically terminate your rights under
+this License (including any patent licenses granted under the third
+paragraph of section 11).
+
+ However, if you cease all violation of this License, then your
+license from a particular copyright holder is reinstated (a)
+provisionally, unless and until the copyright holder explicitly and
+finally terminates your license, and (b) permanently, if the copyright
+holder fails to notify you of the violation by some reasonable means
+prior to 60 days after the cessation.
+
+ Moreover, your license from a particular copyright holder is
+reinstated permanently if the copyright holder notifies you of the
+violation by some reasonable means, this is the first time you have
+received notice of violation of this License (for any work) from that
+copyright holder, and you cure the violation prior to 30 days after
+your receipt of the notice.
+
+ Termination of your rights under this section does not terminate the
+licenses of parties who have received copies or rights from you under
+this License. If your rights have been terminated and not permanently
+reinstated, you do not qualify to receive new licenses for the same
+material under section 10.
+
+ 9. Acceptance Not Required for Having Copies.
+
+ You are not required to accept this License in order to receive or
+run a copy of the Program. Ancillary propagation of a covered work
+occurring solely as a consequence of using peer-to-peer transmission
+to receive a copy likewise does not require acceptance. However,
+nothing other than this License grants you permission to propagate or
+modify any covered work. These actions infringe copyright if you do
+not accept this License. Therefore, by modifying or propagating a
+covered work, you indicate your acceptance of this License to do so.
+
+ 10. Automatic Licensing of Downstream Recipients.
+
+ Each time you convey a covered work, the recipient automatically
+receives a license from the original licensors, to run, modify and
+propagate that work, subject to this License. You are not responsible
+for enforcing compliance by third parties with this License.
+
+ An "entity transaction" is a transaction transferring control of an
+organization, or substantially all assets of one, or subdividing an
+organization, or merging organizations. If propagation of a covered
+work results from an entity transaction, each party to that
+transaction who receives a copy of the work also receives whatever
+licenses to the work the party's predecessor in interest had or could
+give under the previous paragraph, plus a right to possession of the
+Corresponding Source of the work from the predecessor in interest, if
+the predecessor has it or can get it with reasonable efforts.
+
+ You may not impose any further restrictions on the exercise of the
+rights granted or affirmed under this License. For example, you may
+not impose a license fee, royalty, or other charge for exercise of
+rights granted under this License, and you may not initiate litigation
+(including a cross-claim or counterclaim in a lawsuit) alleging that
+any patent claim is infringed by making, using, selling, offering for
+sale, or importing the Program or any portion of it.
+
+ 11. Patents.
+
+ A "contributor" is a copyright holder who authorizes use under this
+License of the Program or a work on which the Program is based. The
+work thus licensed is called the contributor's "contributor version".
+
+ A contributor's "essential patent claims" are all patent claims
+owned or controlled by the contributor, whether already acquired or
+hereafter acquired, that would be infringed by some manner, permitted
+by this License, of making, using, or selling its contributor version,
+but do not include claims that would be infringed only as a
+consequence of further modification of the contributor version. For
+purposes of this definition, "control" includes the right to grant
+patent sublicenses in a manner consistent with the requirements of
+this License.
+
+ Each contributor grants you a non-exclusive, worldwide, royalty-free
+patent license under the contributor's essential patent claims, to
+make, use, sell, offer for sale, import and otherwise run, modify and
+propagate the contents of its contributor version.
+
+ In the following three paragraphs, a "patent license" is any express
+agreement or commitment, however denominated, not to enforce a patent
+(such as an express permission to practice a patent or covenant not to
+sue for patent infringement). To "grant" such a patent license to a
+party means to make such an agreement or commitment not to enforce a
+patent against the party.
+
+ If you convey a covered work, knowingly relying on a patent license,
+and the Corresponding Source of the work is not available for anyone
+to copy, free of charge and under the terms of this License, through a
+publicly available network server or other readily accessible means,
+then you must either (1) cause the Corresponding Source to be so
+available, or (2) arrange to deprive yourself of the benefit of the
+patent license for this particular work, or (3) arrange, in a manner
+consistent with the requirements of this License, to extend the patent
+license to downstream recipients. "Knowingly relying" means you have
+actual knowledge that, but for the patent license, your conveying the
+covered work in a country, or your recipient's use of the covered work
+in a country, would infringe one or more identifiable patents in that
+country that you have reason to believe are valid.
+
+ If, pursuant to or in connection with a single transaction or
+arrangement, you convey, or propagate by procuring conveyance of, a
+covered work, and grant a patent license to some of the parties
+receiving the covered work authorizing them to use, propagate, modify
+or convey a specific copy of the covered work, then the patent license
+you grant is automatically extended to all recipients of the covered
+work and works based on it.
+
+ A patent license is "discriminatory" if it does not include within
+the scope of its coverage, prohibits the exercise of, or is
+conditioned on the non-exercise of one or more of the rights that are
+specifically granted under this License. You may not convey a covered
+work if you are a party to an arrangement with a third party that is
+in the business of distributing software, under which you make payment
+to the third party based on the extent of your activity of conveying
+the work, and under which the third party grants, to any of the
+parties who would receive the covered work from you, a discriminatory
+patent license (a) in connection with copies of the covered work
+conveyed by you (or copies made from those copies), or (b) primarily
+for and in connection with specific products or compilations that
+contain the covered work, unless you entered into that arrangement,
+or that patent license was granted, prior to 28 March 2007.
+
+ Nothing in this License shall be construed as excluding or limiting
+any implied license or other defenses to infringement that may
+otherwise be available to you under applicable patent law.
+
+ 12. No Surrender of Others' Freedom.
+
+ If conditions are imposed on you (whether by court order, agreement or
+otherwise) that contradict the conditions of this License, they do not
+excuse you from the conditions of this License. If you cannot convey a
+covered work so as to satisfy simultaneously your obligations under this
+License and any other pertinent obligations, then as a consequence you may
+not convey it at all. For example, if you agree to terms that obligate you
+to collect a royalty for further conveying from those to whom you convey
+the Program, the only way you could satisfy both those terms and this
+License would be to refrain entirely from conveying the Program.
+
+ 13. Use with the GNU Affero General Public License.
+
+ Notwithstanding any other provision of this License, you have
+permission to link or combine any covered work with a work licensed
+under version 3 of the GNU Affero General Public License into a single
+combined work, and to convey the resulting work. The terms of this
+License will continue to apply to the part which is the covered work,
+but the special requirements of the GNU Affero General Public License,
+section 13, concerning interaction through a network will apply to the
+combination as such.
+
+ 14. Revised Versions of this License.
+
+ The Free Software Foundation may publish revised and/or new versions of
+the GNU General Public License from time to time. Such new versions will
+be similar in spirit to the present version, but may differ in detail to
+address new problems or concerns.
+
+ Each version is given a distinguishing version number. If the
+Program specifies that a certain numbered version of the GNU General
+Public License "or any later version" applies to it, you have the
+option of following the terms and conditions either of that numbered
+version or of any later version published by the Free Software
+Foundation. If the Program does not specify a version number of the
+GNU General Public License, you may choose any version ever published
+by the Free Software Foundation.
+
+ If the Program specifies that a proxy can decide which future
+versions of the GNU General Public License can be used, that proxy's
+public statement of acceptance of a version permanently authorizes you
+to choose that version for the Program.
+
+ Later license versions may give you additional or different
+permissions. However, no additional obligations are imposed on any
+author or copyright holder as a result of your choosing to follow a
+later version.
+
+ 15. Disclaimer of Warranty.
+
+ THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY
+APPLICABLE LAW. EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT
+HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY
+OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO,
+THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+PURPOSE. THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM
+IS WITH YOU. SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF
+ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
+
+ 16. Limitation of Liability.
+
+ IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
+WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES AND/OR CONVEYS
+THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES, INCLUDING ANY
+GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE
+USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED TO LOSS OF
+DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD
+PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS),
+EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF
+SUCH DAMAGES.
+
+ 17. Interpretation of Sections 15 and 16.
+
+ If the disclaimer of warranty and limitation of liability provided
+above cannot be given local legal effect according to their terms,
+reviewing courts shall apply local law that most closely approximates
+an absolute waiver of all civil liability in connection with the
+Program, unless a warranty or assumption of liability accompanies a
+copy of the Program in return for a fee.
+
+ END OF TERMS AND CONDITIONS
+
+ How to Apply These Terms to Your New Programs
+
+ If you develop a new program, and you want it to be of the greatest
+possible use to the public, the best way to achieve this is to make it
+free software which everyone can redistribute and change under these terms.
+
+ To do so, attach the following notices to the program. It is safest
+to attach them to the start of each source file to most effectively
+state the exclusion of warranty; and each file should have at least
+the "copyright" line and a pointer to where the full notice is found.
+
+
+ Copyright (C)
+
+ This program is free software: you can redistribute it and/or modify
+ it under the terms of the GNU General Public License as published by
+ the Free Software Foundation, either version 3 of the License, or
+ (at your option) any later version.
+
+ This program is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ GNU General Public License for more details.
+
+ You should have received a copy of the GNU General Public License
+ along with this program. If not, see .
+
+Also add information on how to contact you by electronic and paper mail.
+
+ If the program does terminal interaction, make it output a short
+notice like this when it starts in an interactive mode:
+
+ Copyright (C)
+ This program comes with ABSOLUTELY NO WARRANTY; for details type `show w'.
+ This is free software, and you are welcome to redistribute it
+ under certain conditions; type `show c' for details.
+
+The hypothetical commands `show w' and `show c' should show the appropriate
+parts of the General Public License. Of course, your program's commands
+might be different; for a GUI interface, you would use an "about box".
+
+ You should also get your employer (if you work as a programmer) or school,
+if any, to sign a "copyright disclaimer" for the program, if necessary.
+For more information on this, and how to apply and follow the GNU GPL, see
+.
+
+ The GNU General Public License does not permit incorporating your program
+into proprietary programs. If your program is a subroutine library, you
+may consider it more useful to permit linking proprietary applications with
+the library. If this is what you want to do, use the GNU Lesser General
+Public License instead of this License. But first, please read
+.
diff --git a/x230t/NEWS b/x230t/NEWS
new file mode 100644
index 0000000..e69de29
diff --git a/x230t/README.md b/x230t/README.md
new file mode 100644
index 0000000..18d4914
--- /dev/null
+++ b/x230t/README.md
@@ -0,0 +1,272 @@
+# Skulls - [Thinkpad X230 Tablet](https://pcsupport.lenovo.com/us/en/products/laptops-and-netbooks/thinkpad-x-series-tablet-laptops/thinkpad-x230-tablet)
+
+![seabios_bootmenu](front.jpg)
+
+## Latest release
+Get it from our [release page](https://github.com/merge/coreboot-x230/releases)
+* __coreboot__: We take coreboot's master branch at the time we build a release image.
+* __microcode update__: revision `0x21` from 2019-02-13
+* __SeaBIOS__: version [1.12.1](https://seabios.org/Releases) from 2019-02-04
+
+### release images to choose from
+We release multiple different, but _very similar_ images you can choose from.
+They all should work on all versions of the X230/X230T. These are the
+differences; (xxxxxxxxxx stands for random characters in the filename):
+* `x230t_coreboot_seabios_xxxxxxxxxx_top.rom` includes the _proprietary_
+[VGA BIOS](https://en.wikipedia.org/wiki/Video_BIOS) from [Intel](https://www.intel.com/content/www/us/en/intelligent-systems/intel-embedded-graphics-drivers/faq-bios-firmware.html)
+which is non-free software. It is executed in "secure" mode.
+* `x230t_coreboot_seabios_free_xxxxxxxxxx_top.rom` includes the
+[VGA BIOS](https://en.wikipedia.org/wiki/Video_BIOS)
+[SeaVGABIOS](https://www.seabios.org/SeaVGABIOS) which is free software.
+While technically more interesting, visually this is currently not as
+beautiful:
+ * The [bootspash image is not shown](https://github.com/merge/skulls/issues/59).
+ * Early boot console messages (after your HDD's bootloader has started a kernel) might be [missing](https://github.com/merge/skulls/issues/46).
+
+
+## table of contents
+* [TL;DR](#tldr)
+* [First-time installation](#first-time-installation)
+* [Updating](#updating)
+* [Moving to Heads](#moving-to-heads)
+* [Why does this work](#why-does-this-work)
+* [How to rebuild](#how-to-reproduce-the-release-images)
+
+## TL;DR
+1. run `sudo ./x230t_skulls.sh` on your current X230 Linux system
+2. Power down, remove the battery. Remove the keyboard and palmrest. Connect
+a hardware flasher to an external PC (or a Raspberry Pi with a SPI 8-pin chip clip
+can directly be used), and run
+`sudo ./external_install_bottom.sh` on the lower chip
+and `sudo ./external_install_top.sh` on the top chip of the two.
+3. For updating later, run `./x230t_skulls.sh`. No need to disassemble.
+
+And always use the latest [released](https://github.com/merge/coreboot-x230/releases)
+package. This will be tested. The git master
+branch is _not_ meant to be stable. Use it for testing only.
+
+## First-time installation
+#### before you begin
+Run Linux on your X230 Tablet, install `dmidecode` and run
+`sudo ./x230t_skulls.sh`. It simply prints system information and
+helps you to be up to date.
+
+Make sure you have the latest skulls-x230t package release by running
+`./x230t_skulls.sh -U`.
+
+#### original BIOS update / EC firmware (optional)
+If the script, `sudo ./x230t_skulls.sh` says "The installed original BIOS is very
+old.", it means that you have a BIOS version that may include an EC version
+older than 1.14.
+
+If that's the case, consider doing one original Lenovo upgrade process. This is not
+supported anymore, once you're running coreboot (You'd have to manually
+flash back your backup images first, see later chapters).
+
+This updates the BIOS _and_ Embedded Controller (EC) firmware. The EC
+is not updated anymore, when running coreboot. Since official BIOS release 2.77 and
+its EC version 1.15 Lenovo includes a digital signature check, which prevents
+further firmware patching.
+
+
+You have 2 options:
+
+* use [the latest original CD](https://pcsupport.lenovo.com/us/en/products/laptops-and-netbooks/thinkpad-x-series-tablet-laptops/thinkpad-x230-tablet/downloads/DS029683) and burn it, or
+* use the same, only with a patched EC firmware that allows using any aftermarket-battery:
+(this is only possible up to EC Firmware 1.14)
+By default, only original Lenovo batteries are allowed.
+Thanks to [this](http://zmatt.net/unlocking-my-lenovo-laptop-part-3/)
+[project](https://github.com/eigenmatt/mec-tools) we can use Lenovo's bootable
+upgrade image, change it and create a bootable _USB_ image (even with EC updates
+that allows one to use 3rd party aftermarket batteries). For this, follow instructions
+at [github.com/hamishcoleman/thinkpad-ec](https://github.com/hamishcoleman/thinkpad-ec).
+
+#### preparation: required hardware
+* An 8 Pin SOIC Clip, for example from
+[Pomona electronics](https://www.pomonaelectronics.com/products/test-clips/soic-clip-8-pin)
+(for availability, check
+[aliexpress](https://de.aliexpress.com/item/POMONA-SOIC-CLIP-5250-8pin-eeprom-for-tacho-8pin-cable-for-pomana-soic-8pin/32814247676.html) or
+[elsewhere](https://geizhals.eu/?fs=pomona+test+clip+5250))
+or alternatively hooks like
+[E-Z-Hook XKM](https://e-z-hook.com/test-hooks/micro-hook/xkm/)
+* 6 [female](https://electronics.stackexchange.com/questions/37783/how-can-i-create-a-female-jumper-wire-connector)
+[jumper wires](https://en.wikipedia.org/wiki/Jump_wire) like
+[these](https://geizhals.eu/jumper-cable-female-female-20cm-a1471094.html)
+to connect the clip to a hardware flasher (if not included with the clip)
+* a hardware flasher
+[supported by flashrom](https://www.flashrom.org/Flashrom/0.9.9/Supported_Hardware#USB_Devices), see below for the examples we support
+
+#### open up the X230
+Remove the 7 screws of your X230 to remove the keyboard (by pushing it towards the
+screen before lifting) and the palmrest. You'll find the chips using the photo
+below. This is how the SPI connection looks like on both of the X230's chips:
+
+
+ Screen (furthest from you)
+![ ______
+ MOSI 5 --| |-- 4 GND
+ CLK 6 --| |-- 3 N/C
+ N/C 7 --| |-- 2 MISO
+ VCC 8 --|______|-- 1 CS](soic8.png)
+
+ Edge (closest to you)
+
+
+... choose __one of the following__ supported flashing hardware examples:
+
+#### Hardware Example: Raspberry Pi 3
+A Raspberry Pi can directly be a flasher through it's I/O pins, see below.
+Use a test clip or hooks, see [required hardware](#preparation-required-hardware).
+
+On the RPi we run [Raspbian](https://www.raspberrypi.org/downloads/raspbian/)
+and have the following setup:
+* Connect to the console: Either
+ * connect a screen and a keyboard, or
+ * Use the [Serial connection](https://elinux.org/RPi_Serial_Connection) using a
+USB-to-serial cable (like [Adafruit 954](http://www.adafruit.com/products/954),
+[FTDI TTL-232R-RPI](http://www.ftdichip.com/Products/Cables/RPi.htm) or
+[others](https://geizhals.eu/usb-to-ttl-serial-adapter-cable-a1461312.html)) and
+picocom (`picocom -b 115200 /dev/ttyUSB0`) or minicom
+* in the SD Cards's `/boot/config.txt` file `enable_uart=1` and `dtparam=spi=on`
+* [For flashrom](https://www.flashrom.org/RaspberryPi) we put `spi_bcm2835`
+and `spidev` in /etc/modules
+* [Connect to a wifi](https://www.raspberrypi.org/documentation/configuration/wireless/wireless-cli.md)
+or ethernet to `sudo apt-get install flashrom`
+* connect the Clip to the Raspberry Pi 3 (there are
+[prettier images](https://github.com/splitbrain/rpibplusleaf) too):
+
+
+ Edge of pi (furthest from you)
+ (UART)
+ L GND TX RX CS
+ E | | | |
+ F +---------------------------------------------------------------------------------+
+ T | x x x x x x x x x x x x x x x x x x x x |
+ | x x x x x x x x x x x x x x x x x x x x |
+ E +----------------------------------^---^---^---^-------------------------------^--+
+ D | | | | |
+ G 3.3V MOSIMISO| GND
+ E (VCC) CLK
+ Body of Pi (closest to you)
+
+
+![Raspberry Pi at work](rpi_clip.jpg)
+
+Now copy the Skulls release tarball over to the Rasperry Pi and
+[continue](#unpack-the-skulls-release-archive) on the Pi.
+
+#### Hardware Example: CH341A based
+The CH341A from [Winchiphead](http://www.wch.cn/), a USB interface chip,
+is used by some cheap memory programmers.
+The one we describe can be bought at
+[aliexpress](http://www.aliexpress.com/item/Free-Shipping-CH341A-24-25-Series-EEPROM-Flash-BIOS-DVD-USB-Programmer-DVD-programmer-router-Nine/32583059603.html),
+but it's available [elsewhere](https://geizhals.eu/?fs=ch341a) too.
+This means you need a different computer running a Linux based system here.
+Also, we don't use the included 3,3V power output (provides too little power),
+but a separate power supply. If you don't have any, consider getting a AMS1117
+based supply for a second USB port (like [this](https://de.aliexpress.com/item/1PCS-AMS1117-3-3V-Mini-USB-5V-3-3V-DC-Perfect-Power-Supply-Module/32785334595.html) or [this](https://www.ebay.com/sch/i.html?_nkw=ams1117+usb)).
+
+* Leave the P/S Jumper connected (programmer mode, 1a86:5512 USB device)
+* Connect 3,3V from your external supply to the Pomona clip's (or hook) VCC
+* Connect GND from your external supply to GND on your CH341A programmer
+* Connect your clip or hooks to the rest of the programmer's SPI pins
+* Connect the programmer (and power supply, if USB) to your PC's USB port
+
+![ch341a programmer with extra USB power supply](ch341a.jpg)
+
+#### unpack the Skulls release archive
+
+
+ tar -xf skulls-x230-.tar.xz
+ cd skulls-x230-
+
+
+#### ifd unlock and me_cleaner: the 8MB chip
+
+Flashing the bottom chip (closer to you) is optional. It has the same pinout
+than the upper chip. This allows you to enable/disable in-system flashing
+(without disassembling the Thinkpad) and/or to neuter the
+[Intel Management Engine](https://en.wikipedia.org/wiki/Intel_Management_Engine)
+for [security reasons](https://en.wikipedia.org/wiki/Intel_Management_Engine#Security_vulnerabilities).
+
+
+ sudo ./external_install_bottom.sh -m -k
+
+
+That's it. Keep the backup safe. Here are the options (just so you know):
+
+* The `-m` option applies `me_cleaner -S -d` before flashing back, see
+[me_cleaner](https://github.com/corna/me_cleaner).
+* The `-l` option will (re-)lock your flash ROM, in case you want to force
+yourself (and others) to hardware-flashing, see [updating](#updating).
+
+#### Your BIOS choice: the 4MB chip
+Now it's time to make your choice! Choose one of the images included in our
+release and select it during running:
+
+
+ sudo ./external_install_top.sh -k
+
+
+This selects and flashes it and that's it.
+Keep the backup safe, assemble and
+turn on the X230. coreboot will do hardware init and start SeaBIOS.
+
+## Updating
+If you have locked your flash (i.e. `./external_install_bottom -l`) you can
+flash externally using `external_install_top.sh` just like the
+first time, see above. Only the "upper" 4MB chip has to be written.
+
+It is recommended to do the the update directly on your X230 using Linux
+though. This is considered more safe for your hardware and is very convenient -
+just install the "flashrom" program and run `./x230_skulls.sh`, see below.
+
+1. boot Linux with the `iomem=relaxed` boot parameter (for example in /etc/default/grub `GRUB_CMDLINE_LINUX_DEFAULT`)
+2. [download](https://github.com/merge/skulls/releases) the latest Skulls release tarball and unpack it or check for updates by running `./x230_skulls.sh -U`.
+3. run `sudo ./x230_skulls.sh` and choose the image to flash.
+
+Hint: In case your Linux distribution's GRUB bootloader doesn't use the full
+screen, put the line `GRUB_GFXMODE=1366x768x32` in your `/etc/default/grub` file
+(and run `update_grub`).
+
+## Moving to Heads
+[Heads](http://osresearch.net/) is an alternative BIOS system with advanced
+security features. It's more complicated to use though. When having Skulls
+installed, installing Heads is as easy as updating Skulls. You can directly
+start using it:
+
+* [build Heads](https://github.com/osresearch/heads)
+* boot Linux with the `iomem=relaxed` boot parameter
+* copy Heads' 12M image file `build/x230/coreboot.rom` to Skulls' x230 directory
+* run `sudo ./x230_heads.sh`
+
+That's it. Heads is a completely different project. Please read the
+[documentation](http://osresearch.net/) for how to use it and report bugs
+[over there](https://github.com/osresearch/heads/issues)
+
+Switching back to Skulls is the same as [updating](#updating). Just run
+`./x230_skulls.sh`.
+
+## Why does this work?
+On the X230, there are 2 physical "BIOS" chips. The "upper" 4MB
+one holds the actual bios we can generate using coreboot, and the "lower" 8MB
+one holds the rest that you can [modify yourself once](#first-time-installation),
+if you like, but strictly speaking, you
+[don't need to touch it at all](https://www.coreboot.org/Board:lenovo/x230#Building_Firmware).
+What's this "rest"?
+Mainly a tiny binary used by the Ethernet card and the Intel Management Engine.
+Read the [coreboot documentation](https://doc.coreboot.org/mainboard/lenovo/xx30_series.html)
+for more details.
+
+## how to reproduce the release images
+* `git clone https://github.com/merge/skulls`
+* `cd skulls/x230`
+* `git checkout 0.1.5` for the release you want to build. In this example 0.1.5.
+* `./build.sh` and choose the configuration you want to build
+
+### replace the splashscreen image
+In order to create your own splashscreen image, before building,
+overwrite the `splashscreen.jpg` with your own JPEG, using
+* "Progressive" turned off, and
+* "4:2:0 (chroma quartered)" Subsampling
+
diff --git a/x230t/bootsplash.jpg b/x230t/bootsplash.jpg
new file mode 100644
index 0000000..41d2b91
Binary files /dev/null and b/x230t/bootsplash.jpg differ
diff --git a/x230t/bootsplash.xcf b/x230t/bootsplash.xcf
new file mode 100644
index 0000000..7ebc56a
Binary files /dev/null and b/x230t/bootsplash.xcf differ
diff --git a/x230t/build.sh b/x230t/build.sh
new file mode 100755
index 0000000..cdedeae
--- /dev/null
+++ b/x230t/build.sh
@@ -0,0 +1,81 @@
+#!/bin/bash
+source "util/functions.sh"
+
+warn_not_root
+
+have_config=0
+
+usage()
+{
+ echo "Skulls for the X230 Tablet"
+ echo " Run this script to rebuild a released image"
+ echo ""
+ echo "Usage: $0 [-c ]"
+ echo ""
+ echo " -c to use for flashrom"
+}
+
+args=$(getopt -o c:h -- "$@")
+if [ $? -ne 0 ] ; then
+ usage
+ exit 1
+fi
+
+eval set -- "$args"
+while [ $# -gt 0 ]
+do
+ case "$1" in
+ -c)
+ CONFIGFILE=$2
+ have_config=1
+ shift
+ ;;
+ -h)
+ usage
+ exit 1
+ ;;
+ --)
+ shift
+ break
+ ;;
+ *)
+ echo "Invalid option: $1"
+ exit 1
+ ;;
+ esac
+ shift
+done
+
+if [ ! "$have_config" -gt 0 ] ; then
+ configs_available=$(ls -1 | grep config || true)
+ if [ -z "${configs_available}" ] ; then
+ echo "No config file found. Please add -c "
+ echo ""
+ usage
+ exit 1
+ fi
+
+ prompt="Please select a configuration to use for building or start with the -c option to use a different one:"
+ options=( $(find -maxdepth 1 -name "*config*" -print0 | xargs -0) )
+
+ PS3="$prompt "
+ select CONFIGFILE in "${options[@]}" "Quit" ; do
+ if (( REPLY == 1 + ${#options[@]} )) ; then
+ exit
+
+ elif (( REPLY > 0 && REPLY <= ${#options[@]} )) ; then
+ break
+
+ else
+ echo "Invalid option. Try another one."
+ fi
+ done
+fi
+
+rm -f defconfig-*
+CONFIGFILE_READY=$(echo $CONFIGFILE | cut -d'-' -f2-)
+cp $CONFIGFILE $CONFIGFILE_READY
+
+cd ..
+./build.sh --clean-slate --commit $(ls -1 x230t/defconfig-* | cut -d'-' -f2-) x230t
+rm -f x230t/defconfig-*
diff --git a/x230t/ch341a.jpg b/x230t/ch341a.jpg
new file mode 100644
index 0000000..8d3ff55
Binary files /dev/null and b/x230t/ch341a.jpg differ
diff --git a/x230t/compile.sh b/x230t/compile.sh
new file mode 100755
index 0000000..51c0486
--- /dev/null
+++ b/x230t/compile.sh
@@ -0,0 +1,46 @@
+#!/bin/bash
+# SPDX-License-Identifier: GPL-3.0+
+# Copyright (C) 2018, Tom Hiller
+
+# shellcheck disable=SC1091
+source /home/coreboot/common_scripts/variables.sh
+source /home/coreboot/common_scripts/download_coreboot.sh
+source /home/coreboot/common_scripts/config_and_make.sh
+
+################################################################################
+## MODEL VARIABLES
+################################################################################
+MAINBOARD="lenovo"
+MODEL="x230t"
+
+################################################################################
+
+###############################################
+## download/git clone/git pull Coreboot ##
+###############################################
+downloadOrUpdateCoreboot
+
+##############################
+## Copy config and make ##
+##############################
+configAndMake
+
+#####################
+## Post build ##
+#####################
+if [ ! -f "$DOCKER_COREBOOT_DIR/build/coreboot.rom" ]; then
+ echo "Uh oh. Things did not go according to plan."
+ exit 1;
+else
+ #split out top BIOS
+ if [ ! -z "$COREBOOT_COMMIT" ]; then
+ RELEASEFILE="${MODEL}_coreboot_seabios_$(echo ${COREBOOT_COMMIT} | cut -c 1-10)_top.rom"
+ else
+ RELEASEFILE="coreboot_$MAINBOARD-$MODEL-top.rom"
+ fi
+ dd if="$DOCKER_COREBOOT_DIR/build/coreboot.rom" of="$DOCKER_COREBOOT_DIR/$RELEASEFILE" bs=1M skip=8
+ sha256sum "$DOCKER_COREBOOT_DIR/$RELEASEFILE" > "$DOCKER_COREBOOT_DIR/${RELEASEFILE}".sha256
+ echo "==================== result: ======================"
+ echo "$DOCKER_COREBOOT_DIR/$RELEASEFILE"
+ echo "==================================================="
+fi
diff --git a/x230t/external_install_bottom.sh b/x230t/external_install_bottom.sh
new file mode 100755
index 0000000..f32620f
--- /dev/null
+++ b/x230t/external_install_bottom.sh
@@ -0,0 +1,265 @@
+#!/bin/bash
+# SPDX-License-Identifier: GPL-3.0+
+# Copyright (C) 2018, Martin Kepplinger
+RED='\033[0;31m'
+GREEN='\033[0;32m'
+NC='\033[0m'
+
+set -e
+
+cd "$(dirname "$0")"
+
+IFDTOOL=./util/ifdtool/ifdtool
+ME_CLEANER_PATH=./util/me_cleaner/me_cleaner.py
+have_chipname=0
+have_backupname=0
+me_clean=0
+lock=0
+have_flasher=0
+rpi_frequency=0
+
+usage()
+{
+ echo "Skulls for the X230 Tablet"
+ echo " Run this script on an external computer with a flasher"
+ echo " connected to the X230T's bottom chip (farther away from"
+ echo " the display, closer to you)."
+ echo ""
+ echo "Usage: $0 [-m] [-k ] [-l] [-f ] [-b ] [-c ]"
+ echo ""
+ echo " -f supported flashers: rpi, ch341a"
+ echo " -c flashrom chip name to use"
+ echo " -m apply me_cleaner -S -d"
+ echo " -l lock the flash instead of unlocking it"
+ echo " -k save the current image as"
+ echo " -b frequency of the RPi SPI bus in Hz. default: 128"
+}
+
+args=$(getopt -o f:mlc:k:hb: -- "$@")
+if [ $? -ne 0 ] ; then
+ usage
+ exit 1
+fi
+
+eval set -- "$args"
+while [ $# -gt 0 ]
+do
+ case "$1" in
+ -f)
+ FLASHER=$2
+ have_flasher=1
+ shift
+ ;;
+ -m)
+ me_clean=1
+ ;;
+ -l)
+ lock=1
+ ;;
+ -c)
+ CHIPNAME=$2
+ have_chipname=1
+ shift
+ ;;
+ -k)
+ BACKUPNAME=$2
+ have_backupname=1
+ shift
+ ;;
+ -b)
+ rpi_frequency=$2
+ shift
+ ;;
+ -h)
+ usage
+ exit 1
+ ;;
+ --)
+ shift
+ break
+ ;;
+ *)
+ echo "Invalid option: $1"
+ usage
+ exit 1
+ ;;
+ esac
+ shift
+done
+
+command -v flashrom >/dev/null 2>&1 || { echo -e >&2 "${RED}Please install flashrom and run as root${NC}."; exit 1; }
+command -v make >/dev/null 2>&1 || { echo -e >&2 "${RED}Please install make and a C compiler${NC}."; exit 1; }
+command -v mktemp >/dev/null 2>&1 || { echo -e >&2 "${RED}Please install mktemp (coreutils)${NC}."; exit 1; }
+
+if [ ! "$have_flasher" -gt 0 ] ; then
+ echo "Skulls for the X230"
+ echo ""
+ echo "Please select the hardware you use:"
+ PS3='Please select the hardware flasher: '
+ options=("Raspberry Pi" "CH341A" "Exit")
+ select opt in "${options[@]}"
+ do
+ case $opt in
+ "Raspberry Pi")
+ FLASHER="rpi"
+ break
+ ;;
+ "CH341A")
+ FLASHER="ch341a"
+ break
+ ;;
+ "Exit")
+ exit 0
+ ;;
+ *) echo invalid option;;
+ esac
+ done
+fi
+
+if [ ! "${rpi_frequency}" -gt 0 ] ; then
+ rpi_frequency=512
+fi
+
+programmer=""
+if [ "${FLASHER}" = "rpi" ] ; then
+ echo "Ok. Run this on a Rasperry Pi."
+ programmer="linux_spi:dev=/dev/spidev0.0,spispeed=${rpi_frequency}"
+elif [ "${FLASHER}" = "ch341a" ] ; then
+ echo "Ok. Connect a CH341A programmer"
+ programmer="ch341a_spi"
+else
+ echo "invalid flashrom programmer"
+ usage
+ exit 1
+fi
+
+TEMP_DIR=$(mktemp -d)
+if [ ! -d "$TEMP_DIR" ]; then
+ echo -e "${RED}Error:${NC} Could not create temp dir"
+ rm -rf "${TEMP_DIR}"
+ exit 1
+fi
+
+if [ ! "$have_chipname" -gt 0 ] ; then
+ echo "trying to detect the chip..."
+ flashrom -p ${programmer} &> "${TEMP_DIR}"/chips || true
+ flashrom_error=""
+ flashrom_error=$(cat "${TEMP_DIR}"/chips | grep -i error || true)
+ if [ ! -z "${flashrom_error}" ] ; then
+ usage
+ echo "-------------- flashrom error: ---------------"
+ cat "${TEMP_DIR}"/chips
+ rm -rf "${TEMP_DIR}"
+ exit 1
+ fi
+
+ CHIPNAME=""
+ chip_found=0
+ if [ ! "$chip_found" -gt 0 ] ; then
+ CHIPNAME=$(cat "${TEMP_DIR}"/chips | grep Found | grep "MX25L6406E/MX25L6408E" | grep -oP '"\K[^"\047]+(?=["\047])' || true)
+ if [ ! -z "${CHIPNAME}" ] ; then
+ chip_found=1
+ fi
+ fi
+
+ if [ ! "$chip_found" -gt 0 ] ; then
+ CHIPNAME=$(cat "${TEMP_DIR}"/chips | grep Found | grep "EN25QH64" | grep -o '".*"' | grep -oP '"\K[^"\047]+(?=["\047])' || true)
+ if [ ! -z "${CHIPNAME}" ] ; then
+ chip_found=1
+ fi
+ fi
+
+ if [ ! "$chip_found" -gt 0 ] ; then
+ CHIPNAME=$(cat "${TEMP_DIR}"/chips | grep Found | grep "W25Q64.V" | grep -o '".*"' | grep -oP '"\K[^"\047]+(?=["\047])' || true)
+ if [ ! -z "${CHIPNAME}" ] ; then
+ chip_found=1
+ fi
+ fi
+
+ if [ ! "$chip_found" -gt 0 ] ; then
+ echo "chip not detected."
+ flashrom -p ${programmer} || true
+ rm -rf "${TEMP_DIR}"
+ echo "chip not detected. Please find it manually and rerun with the -c parameter."
+ exit 1
+ else
+ echo -e "Detected ${GREEN}${CHIPNAME}${NC}."
+ fi
+fi
+
+make -C util/ifdtool
+if [ ! -e ${IFDTOOL} ] ; then
+ echo "ifdtool not found at ${IFDTOOL}"
+ exit 1
+fi
+
+if [ ! "$me_clean" -gt 0 ] ; then
+ echo -e "Intel ME will ${RED}not${NC} be cleaned. Use -m if it should be."
+else
+ echo -e "Intel ME will be ${GREEN}cleaned${NC}."
+fi
+
+if [ ! "$lock" -gt 0 ] ; then
+ echo -e "The flash ROM will be ${GREEN}unlocked${NC}."
+else
+ echo -e "The flash ROM will be ${RED}locked${NC}."
+fi
+
+if [ "$me_clean" -gt 0 ] ; then
+ if [ ! -e ${ME_CLEANER_PATH} ] ; then
+ echo "me_cleaner not found at ${ME_CLEANER_PATH}"
+ rm -rf "${TEMP_DIR}"
+ exit 1
+ fi
+fi
+
+echo "Start reading 2 times. Please be patient..."
+flashrom -p ${programmer} -c ${CHIPNAME} -r "${TEMP_DIR}"/test1.rom
+flashrom -p ${programmer} -c ${CHIPNAME} -r "${TEMP_DIR}"/test2.rom
+cmp --silent "${TEMP_DIR}"/test1.rom "${TEMP_DIR}"/test2.rom
+if [ "$have_backupname" -gt 0 ] ; then
+ cp "${TEMP_DIR}"/test1.rom "${BACKUPNAME}"
+ sha256sum "${TEMP_DIR}"/test1.rom > "${BACKUPNAME}".sha256
+ echo "current image saved as ${BACKUPNAME}"
+fi
+
+reference_size=8388608
+TEMP_SIZE=$(wc -c <"$TEMP_DIR/test1.rom")
+if [ ! "$reference_size" -eq "$TEMP_SIZE" ] ; then
+ echo -e "${RED}Error:${NC} didn't read 8M. You might be at the wrong chip."
+ rm -rf "${TEMP_DIR}"
+ exit 1
+fi
+
+echo -e "${GREEN}connection ok${NC}"
+
+echo "start unlocking ..."
+if [ "$me_clean" -gt 0 ] ; then
+ ${ME_CLEANER_PATH} -d -S -O "${TEMP_DIR}"/work.rom "${TEMP_DIR}"/test1.rom
+else
+ cp "${TEMP_DIR}"/test1.rom "${TEMP_DIR}"/work.rom
+fi
+
+if [ ! "$lock" -gt 0 ] ; then
+ ${IFDTOOL} -u "${TEMP_DIR}"/work.rom
+else
+ ${IFDTOOL} -l "${TEMP_DIR}"/work.rom
+fi
+
+if [ ! -e "${TEMP_DIR}"/work.rom.new ] ; then
+ echo -e "${RED}Error:${NC} ifdtool failed. ${TEMP_DIR}/work.rom.new not found."
+ rm -rf "${TEMP_DIR}"
+ exit 1
+fi
+if [ "$me_clean" -gt 0 ] ; then
+ echo -e "${GREEN}ifdtool and me_cleaner ok${NC}"
+else
+ echo -e "${GREEN}ifdtool ok${NC}"
+fi
+make clean -C util/ifdtool
+
+echo "start writing..."
+
+flashrom -p ${programmer} -c "${CHIPNAME}" -w "${TEMP_DIR}"/work.rom.new
+rm -rf "${TEMP_DIR}"
+echo -e "${GREEN}DONE${NC}"
diff --git a/x230t/external_install_top.sh b/x230t/external_install_top.sh
new file mode 100755
index 0000000..47adaec
--- /dev/null
+++ b/x230t/external_install_top.sh
@@ -0,0 +1,219 @@
+#!/bin/bash
+# SPDX-License-Identifier: GPL-3.0+
+# Copyright (C) 2018, Martin Kepplinger
+RED='\033[0;31m'
+GREEN='\033[0;32m'
+NC='\033[0m'
+
+set -e
+
+have_input_image=0
+have_chipname=0
+have_backupname=0
+have_flasher=0
+rpi_frequency=0
+
+usage()
+{
+ echo "Skulls for the X230 Tablet"
+ echo " Run this script on an external computer with a flasher"
+ echo " connected to the X230's top chip (closer to the display"
+ echo " and farther from you)"
+ echo ""
+ echo "Usage: $0 [-i ] [-c ] [-k ] [-f ] [-b ]"
+ echo ""
+ echo " -f supported flashers: rpi, ch341a"
+ echo " -i path to image to flash"
+ echo " -c to use for flashrom"
+ echo " -k save the current image as"
+ echo " -b frequency of the RPi SPI bus in Hz. default: 128"
+}
+
+args=$(getopt -o f:i:c:k:hb: -- "$@")
+if [ $? -ne 0 ] ; then
+ usage
+ exit 1
+fi
+
+eval set -- "$args"
+while [ $# -gt 0 ]
+do
+ case "$1" in
+ -f)
+ FLASHER=$2
+ have_flasher=1
+ shift
+ ;;
+ -i)
+ INPUT_IMAGE_PATH=$2
+ have_input_image=1
+ shift
+ ;;
+ -c)
+ CHIPNAME=$2
+ have_chipname=1
+ shift
+ ;;
+ -k)
+ BACKUPNAME=$2
+ have_backupname=1
+ shift
+ ;;
+ -b)
+ rpi_frequency=$2
+ shift
+ ;;
+ -h)
+ usage
+ exit 1
+ ;;
+ --)
+ shift
+ break
+ ;;
+ *)
+ echo "Invalid option: $1"
+ exit 1
+ ;;
+ esac
+ shift
+done
+
+command -v flashrom >/dev/null 2>&1 || { echo -e >&2 "${RED}Please install flashrom and run as root${NC}."; exit 1; }
+command -v mktemp >/dev/null 2>&1 || { echo -e >&2 "${RED}Please install mktemp (coreutils)${NC}."; exit 1; }
+
+if [ ! "$have_input_image" -gt 0 ] ; then
+ image_available=$(ls -1 | grep x230t_coreboot_seabios || true)
+ if [ -z "${image_available}" ] ; then
+ echo "No image file found. Please add -i "
+ echo ""
+ usage
+ exit 1
+ fi
+
+ prompt="Please select a file to flash or start with the -i option to use a different one:"
+ options=( $(find -maxdepth 1 -name "*rom" -print0 | xargs -0) )
+
+ PS3="$prompt "
+ select INPUT_IMAGE_PATH in "${options[@]}" "Quit" ; do
+ if (( REPLY == 1 + ${#options[@]} )) ; then
+ exit
+
+ elif (( REPLY > 0 && REPLY <= ${#options[@]} )) ; then
+ break
+
+ else
+ echo "Invalid option. Try another one."
+ fi
+ done
+fi
+
+if [ ! "$have_flasher" -gt 0 ] ; then
+ echo "Please select the hardware you use:"
+ PS3='Please select the hardware flasher: '
+ options=("Raspberry Pi" "CH341A" "Quit")
+ select opt in "${options[@]}"
+ do
+ case $opt in
+ "Raspberry Pi")
+ FLASHER="rpi"
+ break
+ ;;
+ "CH341A")
+ FLASHER="ch341a"
+ break
+ ;;
+ "Quit")
+ exit 0
+ ;;
+ *) echo invalid option;;
+ esac
+ done
+fi
+
+if [ ! "${rpi_frequency}" -gt 0 ] ; then
+ rpi_frequency=512
+fi
+
+programmer=""
+if [ "${FLASHER}" = "rpi" ] ; then
+ programmer="linux_spi:dev=/dev/spidev0.0,spispeed=${rpi_frequency}"
+elif [ "${FLASHER}" = "ch341a" ] ; then
+ programmer="ch341a_spi"
+else
+ echo "invalid flashrom programmer"
+ usage
+ exit 1
+fi
+
+TEMP_DIR=$(mktemp -d)
+if [ ! -d "$TEMP_DIR" ]; then
+ echo "${RED}Error:${NC} Could not create temp dir"
+ exit 1
+fi
+
+if [ ! "$have_chipname" -gt 0 ] ; then
+ echo "trying to detect the chip..."
+ flashrom -p ${programmer} &> "${TEMP_DIR}"/chips || true
+ flashrom_error=""
+ flashrom_error=$(cat "${TEMP_DIR}"/chips | grep -i error || true)
+ if [ ! -z "${flashrom_error}" ] ; then
+ cat "${TEMP_DIR}"/chips
+ rm -rf "${TEMP_DIR}"
+ exit 1
+ fi
+
+ CHIPNAME=""
+ chip_found=0
+ if [ ! "$chip_found" -gt 0 ] ; then
+ CHIPNAME=$(cat "${TEMP_DIR}"/chips | grep Found | grep MX25L3206E | grep -oP '"\K[^"\047]+(?=["\047])' || true)
+ if [ ! -z "${CHIPNAME}" ] ; then
+ chip_found=1
+ fi
+ fi
+
+ if [ ! "$chip_found" -gt 0 ] ; then
+ CHIPNAME=$(cat "${TEMP_DIR}"/chips | grep Found | grep EN25QH32 | grep -oP '"\K[^"\047]+(?=["\047])' || true)
+ if [ ! -z "${CHIPNAME}" ] ; then
+ chip_found=1
+ fi
+ fi
+
+ if [ ! "$chip_found" -gt 0 ] ; then
+ echo "chip not detected."
+ flashrom -p ${programmer} || true
+ rm -rf "${TEMP_DIR}"
+ echo "Please find it manually in the list above and rerun with the -c parameter."
+ exit 1
+ else
+ echo -e "Detected ${GREEN}${CHIPNAME}${NC}."
+ fi
+fi
+
+INPUT_IMAGE_NAME=$(basename "${INPUT_IMAGE_PATH}")
+INPUT_IMAGE_SIZE=$(wc -c < "$INPUT_IMAGE_PATH")
+reference_filesize=4194304
+if [ ! "$INPUT_IMAGE_SIZE" -eq "$reference_filesize" ] ; then
+ echo -e "${RED}Error:${NC} input file must be 4MB of size"
+ exit 1
+fi
+
+echo "verifying SPI connection by reading 2 times. please wait."
+flashrom -p ${programmer} -c ${CHIPNAME} -r ${TEMP_DIR}/test1.rom
+flashrom -p ${programmer} -c ${CHIPNAME} -r ${TEMP_DIR}/test2.rom
+cmp --silent "${TEMP_DIR}"/test1.rom "${TEMP_DIR}"/test2.rom
+if [ "$have_backupname" -gt 0 ] ; then
+ cp "${TEMP_DIR}"/test1.rom "${BACKUPNAME}"
+ sha256sum "${TEMP_DIR}"/test1.rom > "${BACKUPNAME}".sha256
+ echo "current image saved as ${BACKUPNAME}"
+fi
+TEMP_SIZE=$(wc -c < "$TEMP_DIR/test1.rom")
+if [ ! "$INPUT_IMAGE_SIZE" -eq "$TEMP_SIZE" ] ; then
+ echo -e "${RED}Error:${NC} read image (${TEMP_SIZE}) has different size that new image $INPUT_IMAGE_NAME (${INPUT_IMAGE_SIZE})"
+ exit 1
+fi
+rm -rf "${TEMP_DIR}"
+
+echo -e "${GREEN}connection ok${NC}. flashing ${INPUT_IMAGE_NAME}"
+flashrom -p ${programmer} -c "${CHIPNAME}" -w "${INPUT_IMAGE_PATH}"
+echo -e "${GREEN}DONE${NC}"
diff --git a/x230t/free-defconfig-4bd6927388 b/x230t/free-defconfig-4bd6927388
new file mode 100644
index 0000000..f0f7983
--- /dev/null
+++ b/x230t/free-defconfig-4bd6927388
@@ -0,0 +1,17 @@
+CONFIG_USE_OPTION_TABLE=y
+CONFIG_USE_BLOBS=y
+CONFIG_BOOTSPLASH_IMAGE=y
+CONFIG_VENDOR_LENOVO=y
+CONFIG_NO_POST=y
+CONFIG_ONBOARD_VGA_IS_PRIMARY=y
+CONFIG_VGA_BIOS=y
+CONFIG_CBFS_SIZE=0x400000
+CONFIG_BOARD_LENOVO_X230T=y
+CONFIG_DRIVERS_PS2_KEYBOARD=y
+CONFIG_PCIEXP_L1_SUB_STATE=y
+CONFIG_PCIEXP_CLK_PM=y
+# CONFIG_H8_BEEP_ON_DEATH is not set
+CONFIG_MAINBOARD_USE_LIBGFXINIT=y
+CONFIG_DEFAULT_CONSOLE_LOGLEVEL_8=y
+CONFIG_COREINFO_SECONDARY_PAYLOAD=y
+CONFIG_NVRAMCUI_SECONDARY_PAYLOAD=y
diff --git a/x230t/front.jpg b/x230t/front.jpg
new file mode 100644
index 0000000..15f3259
Binary files /dev/null and b/x230t/front.jpg differ
diff --git a/x230t/nonfree-defconfig-4bd6927388 b/x230t/nonfree-defconfig-4bd6927388
new file mode 100644
index 0000000..17ee26b
--- /dev/null
+++ b/x230t/nonfree-defconfig-4bd6927388
@@ -0,0 +1,22 @@
+CONFIG_USE_OPTION_TABLE=y
+CONFIG_USE_BLOBS=y
+CONFIG_BOOTSPLASH_IMAGE=y
+CONFIG_VENDOR_LENOVO=y
+CONFIG_NO_POST=y
+CONFIG_ONBOARD_VGA_IS_PRIMARY=y
+CONFIG_VGA_BIOS=y
+CONFIG_CBFS_SIZE=0x400000
+CONFIG_BOARD_LENOVO_X230T=y
+CONFIG_DRIVERS_PS2_KEYBOARD=y
+CONFIG_PCIEXP_L1_SUB_STATE=y
+# CONFIG_S3_VGA_ROM_RUN is not set
+CONFIG_PCIEXP_CLK_PM=y
+# CONFIG_H8_BEEP_ON_DEATH is not set
+CONFIG_VGA_ROM_RUN=y
+CONFIG_PCI_OPTION_ROM_RUN_YABEL=y
+CONFIG_FRAMEBUFFER_SET_VESA_MODE=y
+CONFIG_VBE_LINEAR_FRAMEBUFFER=y
+CONFIG_BOOTSPLASH=y
+CONFIG_DEFAULT_CONSOLE_LOGLEVEL_8=y
+CONFIG_COREINFO_SECONDARY_PAYLOAD=y
+CONFIG_NVRAMCUI_SECONDARY_PAYLOAD=y
diff --git a/x230t/pci8086,0166.rom b/x230t/pci8086,0166.rom
new file mode 100644
index 0000000..458d689
Binary files /dev/null and b/x230t/pci8086,0166.rom differ
diff --git a/x230t/release.sh b/x230t/release.sh
new file mode 100755
index 0000000..5c7f08a
--- /dev/null
+++ b/x230t/release.sh
@@ -0,0 +1,150 @@
+#!/bin/bash
+# SPDX-License-Identifier: GPL-3.0+
+# Copyright (C) 2018, Martin Kepplinger
+#
+# Script to build release-archives with. This requires a checkout from git.
+# WARNING: This script is very dangerous! It may delete any untracked files.
+set -e
+have_version=0
+have_image=0
+have_image_2=0
+
+usage()
+{
+ echo "Usage: $0 -v version -i release_image -f second_release_image"
+}
+
+args=$(getopt -o v:i:f: -- "$@")
+if [ $? -ne 0 ] ; then
+ usage
+ exit 1
+fi
+eval set -- "$args"
+while [ $# -gt 0 ]
+do
+ case "$1" in
+ -i)
+ RELEASE_IMAGE=$2
+ have_image=1
+ shift
+ ;;
+ -f)
+ RELEASE_IMAGE_2=$2
+ have_image_2=1
+ shift
+ ;;
+ -v)
+ version=$2
+ have_version=1
+ shift
+ ;;
+ --)
+ shift
+ break
+ ;;
+ *)
+ echo "Invalid option: $1"
+ usage
+ exit 1
+ ;;
+ esac
+ shift
+done
+
+if [ ! "$have_image" -gt 0 ] ; then
+ echo "we currently need 2 release images"
+ usage
+ exit 1
+fi
+if [ ! "$have_image_2" -gt 0 ] ; then
+ echo "we currently need 2 release images"
+ usage
+ exit 1
+fi
+
+# Do we have a desired version number?
+if [ "$have_version" -gt 0 ] ; then
+ echo "trying to build version $version"
+else
+ echo "please specify a version"
+ usage
+ exit 1
+fi
+
+# Version number sanity check
+if grep "${version}" NEWS
+then
+ echo "configurations seems ok"
+else
+ echo "please check the NEWS file"
+ exit 1
+fi
+
+# Check that we are on master
+branch=$(git rev-parse --abbrev-ref HEAD)
+echo "we are on branch $branch"
+
+if [ ! "${branch}" = "master" ] ; then
+ echo "you don't seem to be on the master branch"
+ exit 1
+fi
+
+if git diff-index --quiet HEAD --; then
+ # no changes
+ echo "there are no uncommitted changes (version bump)"
+ exit 1
+fi
+echo "======================================================"
+echo " are you fine with the following version bump?"
+echo "======================================================"
+git diff
+echo "======================================================"
+read -r -p " Press enter to continue"
+echo "======================================================"
+
+filesize=$(wc -c <"${RELEASE_IMAGE}")
+reference_filesize=4194304
+if [ ! "$filesize" -eq "$reference_filesize" ] ; then
+ echo "filesize of release image is wrong"
+ exit 1
+fi
+filesize=$(wc -c <"${RELEASE_IMAGE_2}")
+reference_filesize=4194304
+if [ ! "$filesize" -eq "$reference_filesize" ] ; then
+ echo "filesize of release image is wrong"
+ exit 1
+fi
+
+RELEASE_DIR="skulls-x230t-${version}"
+rm -rf "$RELEASE_DIR"
+mkdir -p "$RELEASE_DIR"
+
+# copy-in the ROMs
+cp "${RELEASE_IMAGE}" "$RELEASE_DIR"
+cp "${RELEASE_IMAGE_2}" "$RELEASE_DIR"
+
+RELEASE_IMAGE_FILE=$(basename "${RELEASE_IMAGE}")
+sha256sum ${RELEASE_DIR}/${RELEASE_IMAGE_FILE} > "${RELEASE_DIR}/${RELEASE_IMAGE_FILE}.sha256"
+RELEASE_IMAGE_FILE_2=$(basename "${RELEASE_IMAGE_2}")
+sha256sum ${RELEASE_DIR}/${RELEASE_IMAGE_FILE_2} > "${RELEASE_DIR}/${RELEASE_IMAGE_FILE_2}.sha256"
+
+# copy in device independent stuff
+cp ../SOURCE.md "$RELEASE_DIR"
+cp -a ../util "$RELEASE_DIR"
+
+# copy in x230t stuff
+cp -a README.md NEWS LICENSE* \
+ x230t_skulls.sh \
+ external_install_bottom.sh external_install_top.sh \
+ "$RELEASE_DIR"
+
+tar -cJf "$RELEASE_DIR".tar.xz "$RELEASE_DIR"
+
+rm -rf "$RELEASE_DIR"
+
+git commit -a -m "update to ${version}"
+git tag -s "${version}" -m "skulls-x230t ${version}"
+
+sha256sum "$RELEASE_DIR".tar.xz > "$RELEASE_DIR".tar.xz.sha256
+sha512sum "$RELEASE_DIR".tar.xz > "$RELEASE_DIR".tar.xz.sha512
+gpg -b -a "$RELEASE_DIR".tar.xz
diff --git a/x230t/rpi_clip.jpg b/x230t/rpi_clip.jpg
new file mode 100644
index 0000000..44d3b07
Binary files /dev/null and b/x230t/rpi_clip.jpg differ
diff --git a/x230t/soic8.png b/x230t/soic8.png
new file mode 100644
index 0000000..f4e52c5
Binary files /dev/null and b/x230t/soic8.png differ
diff --git a/x230t/util b/x230t/util
new file mode 120000
index 0000000..40c3fc5
--- /dev/null
+++ b/x230t/util
@@ -0,0 +1 @@
+../util
\ No newline at end of file
diff --git a/x230t/x230t_skulls.sh b/x230t/x230t_skulls.sh
new file mode 100755
index 0000000..2a1e1c1
--- /dev/null
+++ b/x230t/x230t_skulls.sh
@@ -0,0 +1,224 @@
+#!/bin/bash
+# SPDX-License-Identifier: GPL-3.0+
+# Copyright (C) 2019, Martin Kepplinger
+
+set -e
+
+cd "$(dirname "$0")"
+
+source "util/functions.sh"
+
+have_input_image=0
+request_update=0
+verbose=0
+
+usage()
+{
+ echo "Skulls for the X230 Tablet"
+ echo " Run this script on the X230 Tablet directly."
+ echo ""
+ echo " This flashes the BIOS with the given image."
+ echo " Make sure you booted Linux with iomem=relaxed"
+ echo ""
+ echo "Usage: $0 [-i <4mb_top_image>.rom] [-U] [-h]"
+ echo "Options:"
+ echo " -i path to the image to flash"
+ echo " -U update: check for a new Skulls package online"
+ echo " -v verbose output. prints more information"
+ echo " -h print this help text"
+}
+
+args=$(getopt -o i:hUv -- "$@")
+if [ $? -ne 0 ] ; then
+ usage
+ exit 1
+fi
+
+eval set -- "$args"
+while [ $# -gt 0 ]
+do
+ case "$1" in
+ -i)
+ INPUT_IMAGE_PATH=$2
+ have_input_image=1
+ shift
+ ;;
+ -h)
+ usage
+ exit 1
+ ;;
+ -U)
+ request_update=1
+ ;;
+ -v)
+ verbose=1
+ ;;
+ --)
+ shift
+ break
+ ;;
+ *)
+ echo "Invalid option: $1"
+ exit 1
+ ;;
+ esac
+ shift
+done
+
+if [ "$request_update" -gt 0 ] ; then
+ warn_not_root
+
+ command -v curl >/dev/null 2>&1 || { echo -e >&2 "${RED}Please install curl.${NC}"; exit 1; }
+
+ CURRENT_VERSION=$(head -2 NEWS | egrep -o "([0-9]{1,}\.)+[0-9]{1,}")
+
+ UPSTREAM_FILE=$(curl -s https://api.github.com/repos/merge/skulls/releases/latest | grep browser_download_url | cut -d'"' -f4 | cut -d'/' -f9 | head -n 1)
+
+ UPSTREAM_VERSION=$(curl -s https://api.github.com/repos/merge/skulls/releases/latest | grep browser_download_url | cut -d'"' -f4 | cut -d'/' -f9 | head -n 1 | egrep -o "([0-9]{1,}\.)+[0-9]{1,}")
+
+ UPSTREAM_X230T=$(echo ${UPSTREAM_FILE} | grep x230t)
+ if [[ -z "$UPSTREAM_X230T" ]] ; then
+ echo "The latest release didn't include the X230 Tablet"
+ exit 0
+ fi
+
+ if [[ $verbose -gt 0 ]] ; then
+ echo "This is v$CURRENT_VERSION and latest is v$UPSTREAM_VERSION"
+ fi
+
+ if [[ "$CURRENT_VERSION" = "$UPSTREAM_VERSION" ]] ; then
+ echo -e "${GREEN}You are using the latest version of Skulls for the X230 Tablet${NC}"
+ exit 0
+ elif [[ "$CURRENT_VERSION" < "$UPSTREAM_VERSION" ]] ; then
+ echo -e "${RED}You have ${CURRENT_VERSION} but there is version ${UPSTREAM_VERSION} available for the X230 Tablet. Please update.${NC}"
+ read -r -p "Download it to the parent directory now? [y/N] " response
+ case "$response" in
+ [yY][eE][sS]|[yY])
+ UPSTREAM_URL=$(curl -s https://api.github.com/repos/merge/skulls/releases/latest | grep browser_download_url | cut -d'"' -f4 | head -n 1)
+ UPSTREAM_URL_SHA256=$(curl -s https://api.github.com/repos/merge/skulls/releases/latest | grep browser_download_url | cut -d'"' -f4 | head -n 3 | tail -n 1)
+ cd ..
+ curl -LO ${UPSTREAM_URL}
+ curl -LO ${UPSTREAM_URL_SHA256}
+ sha256sum -c ${UPSTREAM_FILE}.sha256
+ mkdir skulls-x230t-${UPSTREAM_VERSION}
+ tar -xf ${UPSTREAM_FILE} -C skulls-x230t-${UPSTREAM_VERSION}/
+ echo "Version ${UPSTREAM_VERSION} extracted to ../skulls-x230t-${UPSTREAM_VERSION}/"
+ echo "Please continue in the new directory."
+ ;;
+ *)
+ exit 0
+ ;;
+ esac
+ else
+ echo "You seem to use a development version. Please use release package skulls-x230t ${UPSTREAM_VERSION} for flashing."
+ fi
+
+ exit 0
+fi
+
+force_x230_and_root
+
+BIOS_VENDOR=$(${DMIDECODE} -t bios | grep Vendor | cut -d':' -f2)
+if [[ $BIOS_VENDOR != *"coreboot"* ]] ; then
+ BIOS_VERSION=$(${DMIDECODE} -s bios-version | grep -o '[1-2].[0-7][0-9]')
+ bios_major=$(echo "$BIOS_VERSION" | cut -d. -f1)
+ bios_minor=$(echo "$BIOS_VERSION" | cut -d. -f2)
+
+ if [ "${bios_minor}" -ge "61" ] ; then
+ echo "Ready to use external_install_bottom.sh and external_install_top.sh"
+ echo "Please run both scripts from a different computer with a"
+ echo "hardware SPI flasher."
+ else
+ echo -e "The installed original BIOS is very old."
+ echo -e "${RED}Please upgrade${NC} from lenovo.com before installing coreboot."
+ fi
+ exit 0
+fi
+
+if [[ "$verbose" -gt 0 ]] ; then
+ if [ -d "/sys/class/power_supply/BAT0" ] ; then
+ bat_last_full=$(cat /sys/class/power_supply/BAT0/charge_full)
+ bat_design_cap=$(cat /sys/class/power_supply/BAT0/charge_full_design)
+ bat_health=$(echo "scale=2 ; $bat_last_full/$bat_design_cap" | bc | sed 's/^\./0./')
+ echo "INFO: Battery hardware health is $bat_health%"
+ fi
+fi
+
+if [ ! "$have_input_image" -gt 0 ] ; then
+ image_available=$(ls -1 | grep x230t_coreboot_seabios || true)
+ if [ -z "${image_available}" ] ; then
+ echo "No image file found. Please add -i "
+ echo ""
+ usage
+ exit 1
+ fi
+
+ prompt="file not specified. Please select a file to flash. Please read the README for details about the differences:"
+ options=( $(find -maxdepth 1 -name "x230t_coreboot_seabios*rom" -print0 | xargs -0) )
+
+ PS3="$prompt "
+ select INPUT_IMAGE_PATH in "${options[@]}" "Quit" ; do
+ if (( REPLY == 1 + ${#options[@]} )) ; then
+ exit
+
+ elif (( REPLY > 0 && REPLY <= ${#options[@]} )) ; then
+ break
+
+ else
+ echo "Invalid option. Try another one."
+ fi
+ done
+fi
+
+
+OUTPUT_PATH=output
+INPUT_IMAGE_NAME=$(basename "${INPUT_IMAGE_PATH}")
+OUTPUT_IMAGE_NAME=${INPUT_IMAGE_NAME%%.*}_prepared_12mb.rom
+OUTPUT_IMAGE_PATH=${OUTPUT_PATH}/${OUTPUT_IMAGE_NAME}
+
+echo -e "input: ${INPUT_IMAGE_NAME}"
+echo -e "output: ${OUTPUT_IMAGE_PATH}"
+
+input_filesize=$(wc -c <"$INPUT_IMAGE_PATH")
+reference_filesize=4194304
+if [ ! "$input_filesize" -eq "$reference_filesize" ] ; then
+ echo "Error: input file must be 4MB of size"
+ exit 1
+fi
+
+rm -rf ${OUTPUT_PATH}
+mkdir ${OUTPUT_PATH}
+
+dd if=/dev/zero of="${OUTPUT_IMAGE_PATH}" bs=4M count=2 status=none
+dd if="${INPUT_IMAGE_PATH}" oflag=append conv=notrunc of="${OUTPUT_IMAGE_PATH}" bs=4M status=none
+
+LAYOUT_FILENAME="x230-layout.txt"
+
+echo "0x00000000:0x00000fff ifd" > ${OUTPUT_PATH}/${LAYOUT_FILENAME}
+echo "0x00001000:0x00002fff gbe" >> ${OUTPUT_PATH}/${LAYOUT_FILENAME}
+echo "0x00003000:0x004fffff me" >> ${OUTPUT_PATH}/${LAYOUT_FILENAME}
+echo "0x00500000:0x007fffff unused" >> ${OUTPUT_PATH}/${LAYOUT_FILENAME}
+echo "0x00800000:0x00bfffff bios" >> ${OUTPUT_PATH}/${LAYOUT_FILENAME}
+
+echo -e "${YELLOW}WARNING${NC}: Make sure not to power off your computer or interrupt this process in any way!"
+echo -e " Interrupting this process may result in irreparable damage to your computer!"
+check_battery
+while true; do
+ read -r -p "Flash the BIOS now? y/N: " yn
+ case $yn in
+ [Yy]* ) cd ${OUTPUT_PATH} && ${FLASHROM} --force --noverify-all -p internal --layout ${LAYOUT_FILENAME} --image bios -w "${OUTPUT_IMAGE_NAME}"; break;;
+ [Nn]* ) exit;;
+ * ) exit;;
+ esac
+done
+
+rm -rf ${OUTPUT_PATH}
+
+while true; do
+ read -r -p "Power off now? (please do!) Y/n: " yn
+ case $yn in
+ [Yy]* ) poweroff ;;
+ [Nn]* ) exit;;
+ * ) poweroff ;;
+ esac
+done